src/Entity/Formation.php
<?php

namespace App\Entity;

use App\Repository\FormationRepository;
use DateTimeInterface;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=FormationRepository::class)
 */
class Formation
{
    /**
     * Début de chemin vers les images
     */
    private const cheminImage = "https://i.ytimg.com/vi/";
    
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $publishedAt;

    /**
     * @ORM\Column(type="string", length=100, nullable=true)
     */
    private $title;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=20, nullable=true)
     */
    private $videoId;

    /**
     * @ORM\ManyToOne(targetEntity=Playlist::class, inversedBy="formations")
     */
    private $playlist;

    /**
     * @ORM\ManyToMany(targetEntity=Categorie::class, inversedBy="formations")
     */
    private $categories;

    public function __construct()
    {
        $this->categories = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getPublishedAt(): ?DateTimeInterface
    {
        return $this->publishedAt;
    }

    public function setPublishedAt(?DateTimeInterface $publishedAt): self
    {
        $this->publishedAt = $publishedAt;

        return $this;
    }
    
    public function getPublishedAtString(): string {
        if($this->publishedAt == null){
            return "";
        }
        return $this->publishedAt->format('d/m/Y');     
    }      

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(?string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getMiniature(): ?string
    {
        return self::cheminImage.$this->videoId."/default.jpg";
    }

    public function getPicture(): ?string
    {
        return self::cheminImage.$this->videoId."/hqdefault.jpg";
    }

    public function getVideoId(): ?string
    {
        return $this->videoId;
    }

    public function setVideoId(?string $videoId): self
    {
        $this->videoId = $videoId;

        return $this;
    }

    public function getPlaylist(): ?Playlist
    {
        return $this->playlist;
    }

    public function setPlaylist(?Playlist $playlist): self
    {
        $this->playlist = $playlist;

        return $this;
    }

    /**
     * @return Collection<int, Categorie>
     */
    public function getCategories(): Collection
    {
        return $this->categories;
    }

    public function addCategory(Categorie $category): self
    {
        if (!$this->categories->contains($category)) {
            $this->categories[] = $category;
        }

        return $this;
    }

    public function removeCategory(Categorie $category): self
    {
        $this->categories->removeElement($category);

        return $this;
    }
}

templates/pages/accueil.html.twig
{% extends "basefront.html.twig" %}

{% block body %}
    <p class="mt-3">
        <h3>Bienvenue sur le site de MediaTek86 consacré aux formations en ligne</h3>
    </p>
    <p class="mt-3">
        Vous allez pouvoir vous former à différents outils numériques gratuitement et directement en ligne.<br />
        Dans la partie <strong><a href="{{ path('formations') }}" class="link-info">Formations</a></strong>, vous trouverez la liste des formations proposées.
        Vous pourrez faire des recherches et des tris. 
        En cliquant sur la capture, vous accèderez à la présentation plus détaillée de la formation ainsi que la vidéo correspondante.<BR />
        Vous pouvez aussi retrouver les vidéos regroupées dans des playlists, dans la partie <strong><a href="{{ path('playlists') }}" class="link-info">Playlists</a></strong>.
    </p>
    <p>
        Voici les <strong>deux dernières formations</strong> ajoutées au catalogue :
        <table class="table">
            <tr>
                {% for formation in formations %}
                    <td>
                        <div class="row">
                            <div class="col">
                                <!-- emplacement photo -->
                                {% if formation.picture %}
                                    <a href="{{ path('formations.showone', {id:formation.id}) }}">
                                    <img src="{{ formation.picture }}" 
                                         class="card-img-top" style="width:100%;height:auto;" alt="{{ formation.title }}">
                                         
                                    </a>    
                                {% endif %}
                            </div>
                            <div class="col">
                                <p>{{ formation.publishedatstring }}</p>
                                <h5 class="text-info mt-1">
                                    {{ formation.title }}
                                </h5>
                                <strong>playlist : </strong>{{ formation.playlist.name }}<br />
                                <strong>catégories : </strong> 
                                {% for categorie in formation.categories %}
                                    {{ categorie.name }}&nbsp;
                                {% endfor %}
                            </div>    
                        </div>                    
                {% endfor %}    
            </tr>

        </table>        
    </p>
{% endblock %}

templates/pages/cgu.html.twig
{% extends "basefront.html.twig" %}

{% block body %}
<section class="container mt-2">
    <h3>Mentions légales du site</h3>
    <p>Conformément aux dispositions des Articles 6-III et 19 de la Loi n°2004-575 du 21 juin 2004 pour la Confiance dans l'économie numérique, dite L.C.E.N., il est porté à la connaissance des utilisateurs et visiteurs du site <u><a href="http://www.mediatekformation.fr">mediatekformation.fr</a></u> les présentes mentions légales.</p>
    <p>Le site mediatekformation est accessible à l'adresse suivante&nbsp;:&nbsp;<u><a href="http://www.mediatekformation.fr">mediatekformation.fr</a></u> (ci-après "<i>le site</i>"). L'accès et l'utilisation du Site sont soumis aux présentes "Mentions légales" détaillées ci-après ainsi qu'aux lois et/ou règlements applicables. La connexion, l'utilisation et l'accès à ce site impliquent l'acceptation intégrale et sans réserve de l'internaute de toutes les dispositions des présentes Mentions Légales.</p>
    <h4>Article 1 - Informations légales</h4>
    <p>En vertu de l'Article 6 de la Loi n° 2004-575 du 21 juin 2004 pour la confiance dans l'économie numérique, il est précisé dans cet article l'identité des différents intervenants dans le cadre de sa réalisation et de son suivi.</p>
    <div class="bd-example">
        <details>
            <summary>A. Éditeur du site (ci-après "<i>l'Éditeur</i>")</summary>
            <address>
                <strong>Jacques Lefevre</strong>
                <br>rue du Colonel Driant 
                <br>75001 Paris
                <br>Téléphone&nbsp;:&nbsp;0102030405
                <br>Courriel&nbsp;:&nbsp;contact@mediatekformation.fr
                <br>RCS&nbsp;:&nbsp;123456789
            </address>
        </details>
        <details>
            <summary>B. Hébergeur du site (ci-après "<i>l'Hébergeur</i>")</summary>
            <address>
                <strong>PlanetHoster</strong>
                <br>4416 Louis-B.-Mayer
                <br>Laval, Québec
                <br>H7P 0G1 Canada
                <br>Téléphone&nbsp;:&nbsp;0102030405
                <br>Courriel&nbsp;:&nbsp;contact@planethoster.com
            </address>
        </details>
        <details>
            <summary>C. Utilisateurs (ci-après "<i>les Utilisateurs</i>")</summary>
            <p>Sont considérés comme utilisateurs tous les internautes qui naviguent, lisent, visionnent et utilisent le site mediatekformation.</p>
        </details>
    </div>
    <h4 class="mt-3">Article 2 - Confidentialité</h4>
    <div class="bd-example">
        Le site ne collecte pas de données.
    </div>
    <h4 class="mt-3">Article 3 - accessibilité</h4>
    <p>Le Site est par principe accessible aux Utilisateurs 24/24h et 7/7j, sauf interruption, programmée ou non, pour des besoins de maintenance ou en cas de force majeure.</p>
    <p>En cas d'impossibilité d'accès au Site, celui-ci s'engage à faire son maximum afin d'en rétablir l'accès. Le Site ne saurait être tenu pour responsable de tout dommage, quelle qu'en soit la nature, résultant de son indisponibilité.</p>
    <h4 class="mt-3">Article 4 - loi applicable et juridiction</h4>
    <p>Les présentes Mentions Légales sont régies par la loi française. En cas de différend et à défaut d'accord amiable, le litige sera porté devant les tribunaux français conformément aux règles de compétence en vigueur.</p>
    <h4 class="mt-3">Article 5 - contact</h4>
    <p>Pour tout signalement de contenus ou d'activités illicites, l'Utilisateur peut contacter l'Éditeur à l'adresse suivante&nbsp;:&nbsp;contact@mediatekformation.fr, ou par courrier recommandé avec accusé de réception adressé à l'Éditeur aux coordonnées précisées dans les présentes mentions légales.</p>
    <p>Le site mediatekformation vous souhaite une excellente navigation !</p>
</section>

{% endblock %}
{% block footer %}{% endblock %}

templates/pages/formation.html.twig
{% extends "basefront.html.twig" %}
{% block body %}
    <div class="row mt-3">
        <div class="col">
            <!-- emplacement de la vidéo -->
            {% if formation.videoid %}
                <div style="width: 560px; height: 315px; float: none; clear: both; margin: 2px auto;">
                  <embed
                    src="https://www.youtube.com/embed/{{ formation.videoid }}" 
                    wmode="transparent"
                    type="video/mp4"
                    width="100%" height="100%"
                    allow="autoplay; clipboard-write; encrypted-media; picture-in-picture"
                    allowfullscreen
                    title="YouTube video player"
                  >
                </div>                                             
            {% endif %}
        </div>
        <div class="col">
            {{ formation.publishedatstring }}
            <h4 class="text-info mt-5">{{ formation.title }}</h4>
            <strong>playlist : </strong>{{ formation.playlist.name }}<br />
            <strong>catégories : </strong>
                {% for categorie in formation.categories %}
                    {{ categorie.name }}&nbsp;
                {% endfor %}
            <br /><br />
            <strong>description :</strong><br />
                {{ formation.description|nl2br }}
        </div>
    </div>
{% endblock %}

templates/pages/formations.html.twig
{% extends "basefront.html.twig" %}
{% block body %}
    <table class="table table-striped" >
        <thead>
            <tr>
                <th class="text-left align-top" scope="col">
                    formation<br />
                    <a href="{{ path('formations.sort', {champ:'title', ordre:'ASC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true"><</a>
                    <a href="{{ path('formations.sort', {champ:'title', ordre:'DESC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true">></a>
                    <form class="form-inline mt-1" method="POST" action="{{ path('formations.findallcontain', {champ:'title'}) }}">
                        <div class="form-group mr-1 mb-2">
                            <input type="text" class="sm" name="recherche" 
                                   value="{% if valeur|default and not table|default %}{{ valeur }}{% endif %}">
                            <input type="hidden" name="_token" value="{{ csrf_token('filtre_title') }}">
                            <button type="submit" class="btn btn-info mb-2 btn-sm">filtrer</button>
                        </div>
                    </form>                    
                </th>
                <th class="text-left align-top" scope="col">
                    playlist<br />
                    <a href="{{ path('formations.sort', {table:'playlist', champ:'name', ordre:'ASC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true"><</a>
                    <a href="{{ path('formations.sort', {table:'playlist', champ:'name', ordre:'DESC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true">></a>
                    <form class="form-inline mt-1" method="POST" action="{{ path('formations.findallcontain', {champ:'name', table:'playlist'}) }}">
                        <div class="form-group mr-1 mb-2">
                            <input type="text" class="sm" name="recherche" 
                                   value="{% if valeur|default and table|default and table=='playlist' %}{{ valeur }}{% endif %}">
                            <input type="hidden" name="_token" value="{{ csrf_token('filtre_name') }}">
                            <button type="submit" class="btn btn-info mb-2 btn-sm">filtrer</button>
                        </div>
                    </form>                    
                </th>
                <th class="text-left align-top" scope="col">
                    catégories
                    <form class="form-inline mt-1" method="POST" action="{{ path('formations.findallcontain', {champ:'id', table:'categories'}) }}">
                        <select class="form-select form-select-sm" name="recherche" id="recherche" onchange="this.form.submit()">
                            <option value=""></option>
                            {% for categorie in categories %}
                                <option 
                                    {% if valeur|default and valeur==categorie.id %} 
                                        selected
                                    {% endif %} 
                                    value="{{ categorie.id }}">{{ categorie.name }}
                                </option>
                            {% endfor %}
                        </select>                    
                    </form>            
                </th>
                <th class="text-center align-top" scope="col">
                    date<br />
                    <a href="{{ path('formations.sort', {champ:'publishedAt', ordre:'ASC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true"><</a>
                    <a href="{{ path('formations.sort', {champ:'publishedAt', ordre:'DESC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true">></a>                    
                </th>
                <th class="text-center align-top" scope="col">
                    &nbsp;
                </th>
            </tr>
        </thead>
        <tbody>
            {% for formation in formations %}
                <tr class="align-middle">
                    <td>
                        <h5 class="text-info">
                            {{ formation.title }}
                        </h5>
                    </td>
                    <td class="text-left">
                        {{ formation.playlist.name }}                  
                    </td>                    
                    <td class="text-left">
                        {% for categorie in formation.categories %}
                            {{ categorie.name }}<br />
                        {% endfor %}
                    </td>                    
                    <td class="text-center">
                        {{ formation.publishedatstring }}
                    </td>
                    <td class="text-center">
                        {% if formation.miniature %}
                            <a href="{{ path('formations.showone', {id:formation.id}) }}">
                                <img src="{{ formation.miniature }}" alt="miniature formation">
                                
                            </a>
                        {% endif %}
                    </td>
                </tr>
            {% endfor %}
        </tbody>
    </table>
{% endblock %}

templates/pages/playlist.html.twig
{% extends "basefront.html.twig" %}
{% block body %}
    <div class="row mt-3">
        <div class="col">
            <h4 class="text-info mt-5">{{ playlist.name }}</h4>
            <strong>catégories : </strong>
                <!-- boucle pour afficher les catégories -->
                {% set anccategorie = '' %}
                {% for playlist in playlistcategories %}
                    {{ playlist.name }}&nbsp;
                {% endfor %}
            <br /><br />
            <strong>description :</strong><br />
                {{ playlist.description|nl2br }}
        </div>
        <div class="col">
            <!-- boucle sur l'affichage des formations -->
            {% for formation in playlistformations %}
                <div class="row mt-1">
                    <div class="col-md-auto">
                        {% if formation.miniature %}
                            <a href="{{ path('formations.showone', {id:formation.id}) }}">
                                <img src="{{ formation.miniature }}" alt="miniature formation">
                            </a>
                        {% endif %}  
                    </div>
                    <div class="col d-flex align-items-center">
                        <a href="{{ path('formations.showone', {id:formation.id}) }}" 
                           class="link-secondary text-decoration-none">
                            {{ formation.title }}
                        </a>          
                    </div>
                </div>
            {% endfor %}
        </div>
        
    </div>
{% endblock %}

templates/pages/playlists.html.twig
{% extends "basefront.html.twig" %}
{% block body %}
    <table class="table table-striped">
        <thead>
            <tr>
                <th class="text-left align-top" scope="col">
                    playlist<br />
                    <a href="{{ path('playlists.sort', {champ:'name', ordre:'ASC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true"><</a>
                    <a href="{{ path('playlists.sort', {champ:'name', ordre:'DESC'}) }}" class="btn btn-info btn-sm active" role="button" aria-pressed="true">></a>
                    <form class="form-inline mt-1" method="POST" action="{{ path('playlists.findallcontain', {champ:'name'}) }}">
                        <div class="form-group mr-1 mb-2">
                            <input type="text" class="sm" name="recherche" 
                                   value="{% if valeur|default and not table|default %}{{ valeur }}{% endif %}">
                            <input type="hidden" name="_token" value="{{ csrf_token('filtre_name') }}">
                            <button type="submit" class="btn btn-info mb-2 btn-sm">filtrer</button>
                        </div>
                    </form>                    
                </th>
                <th class="text-left align-top" scope="col">
                    catégories
                    <form class="form-inline mt-1" method="POST" action="{{ path('playlists.findallcontain', {champ:'id', table:'categories'}) }}">
                        <select class="form-select form-select-sm" name="recherche" id="recherche" onchange="this.form.submit()">
                            <option value=""></option>
                            {% for categorie in categories %}
                                <option 
                                    {% if valeur|default and valeur==categorie.id %} 
                                        selected
                                    {% endif %} 
                                    value="{{ categorie.id }}">{{ categorie.name }}
                                </option>
                            {% endfor %}
                        </select>                    
                    </form>            
                </th>
                <th class="text-center align-top" scope="col">
                    &nbsp;
                </th>
            </tr>
        </thead>
        <tbody>
            <!-- boucle sur les playlists -->
            {% set ancplaylist = '' %}
            {% for k in 0..playlists|length-1 %}
                <!-- affichage une fois chaque playlist -->
                {% if playlists[k].name != ancplaylist %}
                    {% set ancplaylist = playlists[k].name %}
                    <tr class="align-middle">
                        <td>
                            <h5 class="text-info">
                                {{ playlists[k].name }}
                            </h5>
                        </td>                 
                        <td class="text-left">
                            {{ playlists[k].categoriename }}
                            <!-- boucle sur les playlists identiques pour afficher les categories -->
                            {% if k < playlists|length-1 %}
                                {% for j in k+1..playlists|length-1 %}
                                    <!-- affichage une fois de chaque catégorie -->
                                    {% if ancplaylist == playlists[j].name %}
                                        &nbsp;{{ playlists[j].categoriename }}
                                    {% endif %}                                    
                                {% endfor %}
                            {% endif %}
                        </td>                    
                        <td class="text-center">
                            <a href="{{ path('playlists.showone', {id:playlists[k].id}) }}" class="btn btn-secondary">Voir détail</a>
                        </td>
                    </tr>
                {% endif %}
            {% endfor %}
        </tbody>
    </table>
{% endblock %}